AxisToBinary = {}
AxisToBinary.Metatable = {}

function AxisToBinary.Create(pLimit,pEvent)
  local new = {}
  new._ActiveP = false
  new._ActiveN = false
  new._WaitP = false
  new._WaitN = false
  new._LastValue = 0
  new._Limit = pLimit
  new._Event = pEvent
  setmetatable(new,AxisToBinary.Metatable)
  return new
end

function AxisToBinary:Call(value)
  if value >= self._Limit and not self._ActiveP and not self._WaitP then
    self._ActiveP = true
    self._WaitP = true
    TriggerBinaryEventOn(self._Event.."P")
  elseif self._WaitP then
    local diff = value - self._LastValue
    if diff < 0 and self._ActiveP then
      self._ActiveP = false
      TriggerBinaryEventOff(self._Event.."P")
    end
  end
  if value < self._Limit then
    self._WaitP = false
    if self._ActiveP then
      self._ActiveP = false
      TriggerBinaryEventOff(self._Event.."P")
    end
  end

  if value <= -self._Limit and not self._ActiveN and not self._WaitN then
    self._ActiveN = true
    self._WaitN = true
    TriggerBinaryEventOn(self._Event.."N")
  elseif self._WaitN then
    local diff = value - self._LastValue
    if diff > 0 and self._ActiveN then
      self._ActiveN = false
      TriggerBinaryEventOff(self._Event.."N")
    end
  end
  if value > -self._Limit then
    self._WaitN = false
    if self._ActiveN then
      self._ActiveN = false
      TriggerBinaryEventOff(self._Event.."N")
    end
  end
  self._LastValue = value
end

AxisToBinary.Metatable["__call"] = AxisToBinary.Call
