dofile("lua/repeatevent.lua")

InputScheme = {}
InputScheme.FunctionTable = {}
InputScheme.MetaTable = {}

function InputScheme.Create()
  local new = {}
  new.BinaryEventsByName = {}
  new.BinaryEventsByKey = {}
  new.BinaryEventsOn = {}
  new.BinaryEventsOff = {}
  setmetatable(new,InputScheme.MetaTable)
  return new
end

function InputScheme.FunctionTable.SetBinaryEvent(obj,pName,pKey,pFunction,pRepeat)
  if pFunction == nil then
    error("Function is nil: Name"..pName)
  end

  obj.BinaryEventsByName[pName] = {}
  obj.BinaryEventsByName[pName]._Key = pKey
  obj.BinaryEventsByName[pName]._Function = pFunction
  obj.BinaryEventsByKey[pKey] = {}
  obj.BinaryEventsByKey[pKey]._Name = pName
  obj.BinaryEventsByKey[pKey]._Function = pFunction
  if pRepeat ~= nil then
    if pRepeat < 0 then error("Repeat has to be > 0 ") end
    obj.BinaryEventsByName[pName]._Repeat = pRepeat
    obj.BinaryEventsByKey[pKey]._Repeat = pRepeat
    local repeater = RepeatEvent.Create(pRepeat,pFunction)
    obj.BinaryEventsOn[pKey] = repeater:GetActivator()
    obj.BinaryEventsOff[pKey] = repeater:GetDeactivator()
  else
    obj.BinaryEventsOn[pKey] = pFunction
  end
end

function InputScheme.FunctionTable:DeleteBinaryEvent(pName)
  local key = self:GetBinaryEventByName(pName)
  if key ~= nil then
    if self.BinaryEventsByKey[key]._Name == pName then
      self.BinaryEventsByKey[key] = nil
      self.BinaryEventsOn[key] = nil
      self.BinaryEventsOff[key] = nil
    end
  end
  if self.BinaryEventsByName[pName] ~= nil then
    self.BinaryEventsByName[pName] = nil
  end
end

function InputScheme.FunctionTable.GetBinaryEventByName(obj,pName)
  if obj.BinaryEventsByName[pName] == nil then
    return nil
  else
    local temp = obj.BinaryEventsByName[pName]
    if temp._Repeat == nil then
      return temp._Key,temp._Function
    else
      return temp._Key,temp._Function,temp._Repeat
    end
  end
end

function InputScheme.FunctionTable.GetBinaryEventByKey(obj,pKey)
  if obj.BinaryEventsByKey[pKey] == nil then
    return nil
  else
    local temp = obj.BinaryEventsByKey[pKey]
    if temp._Repeat == nil then
      return temp._Name,temp._Function
    else
      return temp._Name,temp._Function,temp._Repeat
    end
  end
end

function InputScheme.FunctionTable.Use(obj)
  OnBinaryEventOn = obj.BinaryEventsOn
  OnBinaryEventOff = obj.BinaryEventsOff
end

InputScheme.MetaTable["__index"] = InputScheme.FunctionTable
