StateObject = -1
StateObject2 = -1
StateObject3 = -1
MainRendertarget = -1
PostProcessingRendertarget1 = -1
PostProcessingRendertarget2 = -1
SpielfeldModel = -1
SpielfeldMatrix = -1
ModelPos = vec4(0,-1,0,1)
LightPos1 = vec4(5,-10,16,1)
LightColor1 = vec4(1.0,1.0,1.0,1)
GlowColor = vec4(1.0,0.0,0.0,1.0)
LastDraw = -1
Time = 0
MainCamera = -1
ModelMatrix = -1
ViewMatrix = -1
LightPosition = -1
LightDiffuseColor = -1
TextureColor0 = -1
GlowTexture = -1
ScreenQuad = -1
--LightModel = -1

Globals = {}


ModelGlowXml = -1
ModelGlow = -1
HBlurXml = -1
HBlur = -1
VBlurXml = -1
VBlur = -1
GlowTarget = -1
GlowTexture0 = -1
GlowTexture1 = -1
SceneDepthTexture = -1
DeferredBaseXml = -1
DeferredBase = -1
DeferredPointLightXml = -1
DeferredPointLight = -1
EdgeFilterXml = -1
EdgeFilter = -1

dofile("config.lua")
dofile("lua/tetris.lua")
dofile("lua/input.lua")
dofile("lua/table.save-0.94.lua")

function Init()
  collectgarbage("stop")
  Start = Zeitpunkt();

  gui.LoadLanguageFile("lang/"..Config["language"]..".txt")

  if not renderer.TestMrtSupport() then
    gui.SetErrorMessageL("error_no_mrt_support")
    error("Hardware has no multiple rendertargets support")
  end

  if renderer.GetShaderModel() < 1 then
    gui.SetErrorMessageL("error_no_shader_support")
    error("Hardware has no shader support")
  end

  Globals["WindowWidth"] = sys.GetGlobal("WindowWidth")
  Globals["WindowHeight"] = sys.GetGlobal("WindowHeight")

  ScreenQuad = renderer.GetScreenQuad()
  GlowTexture = renderer.NewTexture2D("Glow Texture")
  renderer.LoadPng(GlowTexture,"gfx/texture.png","MIPMAPS","NO_LOCAL_DATA","LINEAR")

  ModelGlowXml = renderer.NewXmlShader("shader/modelglow.xml")
  renderer.XmlShaderUpload(ModelGlowXml)
  ModelGlow = renderer.XmlShaderGetShader(ModelGlowXml)

  DeferredBaseXml = renderer.NewXmlShader("shader/deferredbase.xml")
  renderer.XmlShaderUpload(DeferredBaseXml)
  DeferredBase = renderer.XmlShaderGetShader(DeferredBaseXml)

  DeferredPointLightXml = renderer.NewXmlShader("shader/deferredpointlight.xml")
  renderer.XmlShaderUpload(DeferredPointLightXml)
  DeferredPointLight = renderer.XmlShaderGetShader(DeferredPointLightXml)

  VBlurXml = renderer.NewXmlShader("shader/blurvertical.xml")
  renderer.XmlShaderUpload(VBlurXml)
  VBlur = renderer.XmlShaderGetShader(VBlurXml)

  HBlurXml = renderer.NewXmlShader("shader/blurhorizontal.xml")
  renderer.XmlShaderUpload(HBlurXml)
  HBlur = renderer.XmlShaderGetShader(HBlurXml)

  if Config["outlines"] > 0 then
    EdgeFilterXml = renderer.NewXmlShader("shader/edgefilter.xml")
    renderer.XmlShaderUpload(EdgeFilterXml)
    EdgeFilter = renderer.XmlShaderGetShader(EdgeFilterXml)
  end

  StateObject = renderer.NewStateObject()
  StateObject2 = renderer.NewStateObject()
  renderer.StateObjectSetDepthTest(StateObject2,true)
  StateObject3 = renderer.NewStateObject()
  renderer.StateObjectSetBlending(StateObject3,true)
  renderer.StateObjectSetBlendFunc(StateObject3,"ONE","ONE")

  SpielfeldModel = renderer.NewModel()
  renderer.ModelLoadFile(SpielfeldModel,"gfx/spielfeld.3ds")
  renderer.ModelSetShader(SpielfeldModel,ModelGlow)
  renderer.ModelAddTexture(SpielfeldModel,GlowTexture,0)

  ModelMatrix = renderer.GetShaderConstant("ModelMatrix")
  ViewMatrix = renderer.GetShaderConstant("ViewMatrix")
  LightPosition = renderer.GetShaderConstant("LightPosition")
  LightDiffuseColor = renderer.GetShaderConstant("LightDiffuseColor")
  TextureColor0 = renderer.GetShaderConstant("TextureColor0")

  --Create Main Rendertarget
  local ScreenWidth = Globals["WindowWidth"]
  local ScreenHeight = Globals["WindowHeight"]
  if Config["double_resolution"] then
    ScreenWidth = ScreenWidth * 2
    ScreenHeight = ScreenHeight * 2
  end
  renderer.NewRendertargetBegin()
  if Config["outlines"] > 0 then
    renderer.RendertargetAddTarget("DEPTH_BUFFER_TEXTURE","DEPTH24")
  else
    renderer.RendertargetAddTarget("DEPTH_BUFFER_TEXTURE","DEPTH16")
  end
  renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8") -- Color
  renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8") -- Normal
  renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8") -- Glow
  MainRendertarget = renderer.NewRendertargetEnd(ScreenWidth,ScreenHeight)
  local error_string = renderer.RendertargetGetError(MainRendertarget)
  if error_string ~= nil then
    renderer.DeleteRendertarget(MainRendertarget)
    renderer.NewRendertargetBegin()
    renderer.RendertargetAddTarget("DEPTH_BUFFER_TEXTURE","DEPTH16")
    renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8") -- Color
    renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8") -- Normal
    renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8") -- Glow
    MainRendertarget = renderer.NewRendertargetEnd(ScreenWidth,ScreenHeight)
    error_string = renderer.RendertargetGetError(MainRendertarget)
    if error_string ~= nil then
      error(error_string)
    end
    Config["outlines"] = 0
  end
  renderer.RendertargetPresetTargets(MainRendertarget,0,1,2)
  renderer.SetMainRendertarget(MainRendertarget)
  GlowTexture0 = renderer.RendertargetGetColorTexture(MainRendertarget,2)
  SceneDepthTexture = renderer.RendertargetGetDepthTexture(MainRendertarget)

  --Create Post Processing Rendertarget 1
  renderer.NewRendertargetBegin()
  --renderer.RendertargetAddTarget("DEPTH_BUFFER_TEXTURE","DEPTH16")
  renderer.RendertargetAddTarget("DEPTH_BUFFER","DEPTH")
  renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8")
  PostProcessingRendertarget1 = renderer.NewRendertargetEnd(ScreenWidth,ScreenHeight)
  error_string = renderer.RendertargetGetError(PostProcessingRendertarget1)
  if error_string ~= nil then
    error(error_string)
  end
  renderer.SetPostProcessingRendertarget1(PostProcessingRendertarget1)

  --Create Post Processing Rendertarget 2
  --local DepthTexture = renderer.RendertargetGetDepthTexture(PostProcessingRendertarget1)
  renderer.NewRendertargetBegin()
  --renderer.RendertargetAddTarget("DEPTH_BUFFER_TEXTURE","DEPTH16",DepthTexture)
  renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8")
  PostProcessingRendertarget2 = renderer.NewRendertargetEnd(ScreenWidth,ScreenHeight,PostProcessingRendertarget1)
  error_string = renderer.RendertargetGetError(PostProcessingRendertarget2)
  if error_string ~= nil then
    error(error_string)
  end
  renderer.SetPostProcessingRendertarget2(PostProcessingRendertarget2)

  -- Create Glow Rendertarget
  renderer.NewRendertargetBegin()
  --renderer.RendertargetAddTarget("DEPTH_BUFFER_TEXTURE","DEPTH16",DepthTexture)
  renderer.RendertargetAddTarget("COLOR_BUFFER","RGBA8")
  GlowTarget = renderer.NewRendertargetEnd(ScreenWidth,ScreenHeight,PostProcessingRendertarget1)
  error_string = renderer.RendertargetGetError(GlowTarget)
  if error_string ~= nil then
    error(error_string)
  end
  GlowTexture1 = renderer.RendertargetGetColorTexture(GlowTarget,0)

  --Add Task Draw()
  DrawTask = tsk.New("LuaDraw","Draw")
  GarbageTask = tsk.New("Garbage Collector","CollectTheGarbage")
  OpenGLTask = tsk.GetTaskId("OpenGL Renderer")
  Profiler = tsk.GetTaskId("Profiler")
  tsk.AddDependencie(OpenGLTask,DrawTask)
  tsk.AddDependencie(Profiler,DrawTask)
  tsk.AddDependencie(Profiler,GarbageTask)

  tsk.AddDependencie(GarbageTask,DrawTask)

  --Setup Camera
  MainCamera = renderer.NewCamera()
  renderer.CameraSetFrom(MainCamera,vec4(25,-40,24,1))
  renderer.CameraSetTo(MainCamera,vec4(5,0,16,1))

  --renderer.CameraSetFrom(MainCamera,vec4(0,-50,16,1))
  --renderer.CameraSetTo(MainCamera,vec4(0,0,16,1))

  SpielfeldMatrix = math3d.TranslationMatrix(vec4(5.0,0.0,0.0,1.0))

  renderer.RenderSliceSetPostProcessing(2,true)

  -- Setup Tetris
  InitTetris()

  --[[ Test
  LightModel = renderer.NewModel()
  renderer.ModelLoadFile(LightModel,"gfx/light.3DS")
  renderer.ModelSetShader(LightModel,renderer.XmlShaderGetShader(ModelNoTextureGlowXml))]]

  Stop = Zeitpunkt();
  LastDraw = Stop
  io.write("Init took "..(Stop-Start).." ms\n")
end

function DeInit()
  DeInitTetris()
  if MainRendertarget ~= -1 then
    renderer.DeleteRendertarget(MainRendertarget)
  end
  if PostProcessingRendertarget1 ~= -1 then
    renderer.DeleteRendertarget(PostProcessingRendertarget1)
  end
  if PostProcessingRendertarget2 ~= -1 then
    renderer.DeleteRendertarget(PostProcessingRendertarget2)
  end
  if GlowTarget ~= -1 then
    renderer.DeleteRendertarget(GlowTarget)
  end
  if MainCamera ~= -1 then
    renderer.DeleteCamera(MainCamera)
  end
end

function Draw()
  CurrentDraw = Zeitpunkt()
  local TimeDiff = CurrentDraw - LastDraw
  UpdateTetris(TimeDiff)

  --Recompute Camera Pos
  Time = Time + TimeDiff / 200
  if Time > 360 then Time = Time - 360 end
  renderer.CameraSetFrom(MainCamera,vec4(math.sin(Time / 180 * math.pi)*15+5,-40,24,1))

  -- Draw Scene
  local RenderGroup = renderer.AddRenderGroup(0)
  renderer.CameraRecalc(MainCamera)
  local CameraMatrix = renderer.CameraGetCameraMatrix(MainCamera)
  renderer.RenderGroupOverrideMat4(RenderGroup,ViewMatrix,CameraMatrix)

  -- Draw the Spielfeld
  local DrawSpielfeld = renderer.ModelDraw(SpielfeldModel,StateObject2,RenderGroup)
  renderer.RenderCallOverrideMat4(DrawSpielfeld,ModelMatrix,SpielfeldMatrix)
  renderer.RenderCallOverrideVec4(DrawSpielfeld,TextureColor0,GlowColor)

  -- Draw Tetris
  DrawTetris(RenderGroup)

  --[[Draw Light
  local DrawLight = renderer.ModelDraw(LightModel,StateObject2,RenderGroup)
  renderer.RenderCallOverrideMat4(DrawLight,ModelMatrix,math3d.TranslationMatrix(LightPos1))
  renderer.RenderCallOverrideVec4(DrawLight,TextureColor0,vec4(1,1,0,1))]]

  --Draw Deferred Pass
  local RenderGroup2 = renderer.AddRenderGroup(1)
  renderer.RenderGroupSetPostProcessingRendertarget(RenderGroup2)
  renderer.RenderGroupAddRendertargetBinding(RenderGroup2,0,0)
  renderer.RenderGroupAddRendertargetBinding(RenderGroup2,1,1)
  renderer.RenderGroupAddRendertargetBinding(RenderGroup2,-1,2)

  -- Draw Ambient Light
  local RenderCall3 = renderer.AddRenderCall(RenderGroup2)
  renderer.RenderCallSetShader(RenderCall3,DeferredBase)
  renderer.RenderCallSetVertexBuffer(RenderCall3,ScreenQuad)
  renderer.RenderCallSetStateObject(RenderCall3,StateObject)

  --Light 1
  local DrawLight1 = renderer.AddRenderCall(RenderGroup2)
  renderer.RenderCallSetShader(DrawLight1,DeferredPointLight)
  renderer.RenderCallSetVertexBuffer(DrawLight1,ScreenQuad)
  renderer.RenderCallSetStateObject(DrawLight1,StateObject3)
  local TempLightPos = CameraMatrix * LightPos1
  renderer.RenderCallOverrideVec4(DrawLight1,LightPosition,TempLightPos)
  renderer.RenderCallOverrideVec4(DrawLight1,LightDiffuseColor,LightColor1);

  --Edge Filter
  if Config["outlines"] > 0 then
    local Edge = renderer.AddRenderGroup(2)
    renderer.RenderGroupAddRendertargetBinding(Edge,0,0)
    renderer.RenderGroupSetPostProcessingRendertarget(Edge)

    local EdgeCall = renderer.AddRenderCall(Edge)
    renderer.RenderCallSetShader(EdgeCall,EdgeFilter)
    renderer.RenderCallSetVertexBuffer(EdgeCall,ScreenQuad)
    renderer.RenderCallSetStateObject(EdgeCall,StateObject)
    renderer.RenderCallAddTexture(EdgeCall,SceneDepthTexture,1)
  end

  --Glow
  local Glow1 = renderer.AddRenderGroup(2)
  renderer.RenderGroupSetRendertarget(Glow1,GlowTarget)

  local Glow1Call = renderer.AddRenderCall(Glow1)
  renderer.RenderCallSetShader(Glow1Call,HBlur)
  renderer.RenderCallSetVertexBuffer(Glow1Call,ScreenQuad)
  renderer.RenderCallSetStateObject(Glow1Call,StateObject)
  renderer.RenderCallAddTexture(Glow1Call,GlowTexture0,0)

  local Glow2 = renderer.AddRenderGroup(2)
  renderer.RenderGroupAddRendertargetBinding(Glow2,0,1) -- Bind Color info to 1
  renderer.RenderGroupSetPostProcessingRendertarget(Glow2)

  local Glow2Call = renderer.AddRenderCall(Glow2)
  renderer.RenderCallSetShader(Glow2Call,VBlur)
  renderer.RenderCallSetVertexBuffer(Glow2Call,ScreenQuad)
  renderer.RenderCallSetStateObject(Glow2Call,StateObject)
  renderer.RenderCallAddTexture(Glow2Call,GlowTexture1,0)


  LastDraw = CurrentDraw
end

function CollectTheGarbage()
  collectgarbage("collect")
end
